diff -urN punbb-1.4.1/include/dblayer/mysql_innodb.php punbb-1.4.2/include/dblayer/mysql_innodb.php
--- punbb-1.4.1/include/dblayer/mysql_innodb.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/mysql_innodb.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the MySQL PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -80,7 +80,7 @@
 		if (strlen($sql) > 140000)
 			exit('Insane query. Aborting.');
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		if ($unbuffered)
@@ -90,7 +90,7 @@
 
 		if ($this->query_result)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -99,7 +99,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			if ($this->in_transaction)
diff -urN punbb-1.4.1/include/dblayer/mysqli.php punbb-1.4.2/include/dblayer/mysqli.php
--- punbb-1.4.1/include/dblayer/mysqli.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/mysqli.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the MySQLi PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -41,7 +41,7 @@
 			$this->link_id = @mysqli_connect($db_host, $db_username, $db_password, $db_name);
 
 		if (!$this->link_id)
-			error('Unable to connect to MySQL and select database.<br/>MySQL reported: '.mysqli_connect_error(), __FILE__, __LINE__);
+			error('Unable to connect to MySQL and select database.<br />MySQL reported: '.mysqli_connect_error(), __FILE__, __LINE__);
 
 		// Setup the client-server character set (UTF-8)
 		if (!defined('FORUM_NO_SET_NAMES'))
@@ -68,14 +68,14 @@
 		if (strlen($sql) > 140000)
 			exit('Insane query. Aborting.');
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		$this->query_result = @mysqli_query($this->link_id, $sql);
 
 		if ($this->query_result)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -84,7 +84,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			return false;
diff -urN punbb-1.4.1/include/dblayer/mysql.php punbb-1.4.2/include/dblayer/mysql.php
--- punbb-1.4.1/include/dblayer/mysql.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/mysql.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the MySQL PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -69,7 +69,7 @@
 		if (strlen($sql) > 140000)
 			exit('Insane query. Aborting.');
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		if ($unbuffered)
@@ -79,7 +79,7 @@
 
 		if ($this->query_result)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -88,7 +88,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			return false;
diff -urN punbb-1.4.1/include/dblayer/pgsql.php punbb-1.4.2/include/dblayer/pgsql.php
--- punbb-1.4.1/include/dblayer/pgsql.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/pgsql.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the PostgreSQL PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -107,7 +107,7 @@
 		if (strrpos($sql, 'LIMIT') !== false)
 			$sql = preg_replace('#LIMIT ([0-9]+),([ 0-9]+)#', 'LIMIT \\2 OFFSET \\1', $sql);
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		@pg_send_query($this->link_id, $sql);
@@ -115,7 +115,7 @@
 
 		if (pg_result_status($this->query_result) != PGSQL_FATAL_ERROR)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -126,7 +126,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			$this->error_msg = @pg_result_error($this->query_result);
@@ -326,7 +326,7 @@
 		{
 			if ($this->in_transaction)
 			{
-				if (defined('FORUM_SHOW_QUERIES'))
+				if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 					$this->saved_queries[] = array('COMMIT', 0);
 
 				@pg_query($this->link_id, 'COMMIT');
diff -urN punbb-1.4.1/include/dblayer/sqlite3.php punbb-1.4.2/include/dblayer/sqlite3.php
--- punbb-1.4.1/include/dblayer/sqlite3.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/sqlite3.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the SQLite PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -90,14 +90,14 @@
 		if (strlen($sql) > 140000)
 			exit('Insane query. Aborting.');
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		$this->query_result = $this->link_id->query($sql);
 
 		if ($this->query_result)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -106,7 +106,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			$this->error_no = $this->link_id->lastErrorCode();
@@ -333,7 +333,7 @@
 		{
 			if ($this->in_transaction)
 			{
-				if (defined('FORUM_SHOW_QUERIES'))
+				if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 					$this->saved_queries[] = array('COMMIT', 0);
 
 				$this->link_id->exec('COMMIT');
diff -urN punbb-1.4.1/include/dblayer/sqlite.php punbb-1.4.2/include/dblayer/sqlite.php
--- punbb-1.4.1/include/dblayer/sqlite.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/sqlite.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the SQLite PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -93,7 +93,7 @@
 		if (strlen($sql) > 140000)
 			exit('Insane query. Aborting.');
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		if ($unbuffered)
@@ -103,7 +103,7 @@
 
 		if ($this->query_result)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -112,7 +112,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			$this->error_no = @sqlite_last_error($this->link_id);
@@ -325,7 +325,7 @@
 		{
 			if ($this->in_transaction)
 			{
-				if (defined('FORUM_SHOW_QUERIES'))
+				if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 					$this->saved_queries[] = array('COMMIT', 0);
 
 				@sqlite_query($this->link_id, 'COMMIT');
diff -urN punbb-1.4.1/include/email.php punbb-1.4.2/include/email.php
--- punbb-1.4.1/include/email.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/email.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads functions used in dealing with email addresses and email sending.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -117,11 +117,11 @@
 	while (substr($server_response, 3, 1) != ' ')
 	{
 		if (!($server_response = fgets($socket, 256)))
-			error('Couldn\'t get mail server response codes.<br/>Please contact the forum administrator.', __FILE__, __LINE__);
+			error('Couldn\'t get mail server response codes.<br />Please contact the forum administrator.', __FILE__, __LINE__);
 	}
 
 	if (!(substr($server_response, 0, 3) == $expected_response))
-		error('Unable to send e-mail.<br/>Please contact the forum administrator with the following error message reported by the SMTP server: "'.$server_response.'"', __FILE__, __LINE__);
+		error('Unable to send e-mail.<br />Please contact the forum administrator with the following error message reported by the SMTP server: "'.$server_response.'"', __FILE__, __LINE__);
 }
 
 
diff -urN punbb-1.4.1/include/essentials.php punbb-1.4.2/include/essentials.php
--- punbb-1.4.1/include/essentials.php	2011-11-27 18:23:16.000000000 +0000
+++ punbb-1.4.2/include/essentials.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads the minimum amount of data (eg: functions, database connection, config data, etc) necessary to integrate the site.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -11,7 +11,7 @@
 	exit('The constant FORUM_ROOT must be defined and point to a valid PunBB installation root directory.');
 
 // Define the version and database revision that this code was written for
-define('FORUM_VERSION', '1.4.1');
+define('FORUM_VERSION', '1.4.2');
 define('FORUM_DB_REVISION', 5);
 
 // Record the start time (will be used to calculate the generation time for the page)
@@ -22,8 +22,6 @@
 require FORUM_ROOT.'include/functions.php';
 // Load the Loader class
 require FORUM_ROOT.'include/loader.php';
-// Load the Flash messenger class
-require FORUM_ROOT.'include/flash_messenger.php';
 
 // Load UTF-8 functions
 require FORUM_ROOT.'include/utf8/utf8.php';
@@ -46,7 +44,7 @@
 	define('FORUM', 1);
 
 if (!defined('FORUM'))
-	error('The file \'config.php\' doesn\'t exist or is corrupt.<br/>Please run <a href="'.FORUM_ROOT.'admin/install.php">install.php</a> to install PunBB first.');
+	error('The file \'config.php\' doesn\'t exist or is corrupt.<br />Please run <a href="'.FORUM_ROOT.'admin/install.php">install.php</a> to install PunBB first.');
 
 // Block prefetch requests
 if (isset($_SERVER['HTTP_X_MOZ']) && $_SERVER['HTTP_X_MOZ'] == 'prefetch')
@@ -100,6 +98,9 @@
 	require FORUM_CACHE_DIR.'cache_config.php';
 }
 
+// Load the Flash messenger class
+require FORUM_ROOT.'include/flash_messenger.php';
+
 // If the request_uri is invalid try fix it
 forum_fix_request_uri();
 
@@ -115,7 +116,7 @@
 
 // Verify that we are running the proper database schema revision
 if (defined('PUN') || !isset($forum_config['o_database_revision']) || $forum_config['o_database_revision'] < FORUM_DB_REVISION || version_compare($forum_config['o_cur_version'], FORUM_VERSION, '<'))
-	error('Your PunBB database is out-of-date and must be upgraded in order to continue.<br/>Please run <a href="'.$base_url.'/admin/db_update.php">db_update.php</a> in order to complete the upgrade process.');
+	error('Your PunBB database is out-of-date and must be upgraded in order to continue.<br />Please run <a href="'.$base_url.'/admin/db_update.php">db_update.php</a> in order to complete the upgrade process.');
 
 
 // Load hooks
diff -urN punbb-1.4.1/include/flash_messenger.php punbb-1.4.2/include/flash_messenger.php
--- punbb-1.4.1/include/flash_messenger.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/flash_messenger.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads the flash messenger class.
  *
- * @copyright (C) 2008-2011 PunBB
+ * @copyright (C) 2008-2012 PunBB
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -19,14 +19,22 @@
 	const MSG_TYPE_INFO = 'message_info';
 
 	//
-	private $messages;
+	private $message;
 
 
 	public function __construct()
 	{
-		session_cache_limiter(FALSE);
-		$result = session_start();
-		$this->messages = $this->get_messages();
+		global $forum_config;
+
+		// Do not use with redirect
+		$disabled = isset($forum_config['o_redirect_delay']) && intval($forum_config['o_redirect_delay'], 10) > 0;
+
+		if (!$disabled)
+		{
+			forum_session_start();
+		}
+
+		$this->message = $this->get_message();
 	}
 
 
@@ -54,26 +62,19 @@
 	//
 	public function show($just_return = false)
 	{
-		if (empty($this->messages))
+		if (empty($this->message))
 			return;
 
-		$messages_list = array();
-		foreach ($this->messages as $msg)
-		{
-			$messages_list[] = sprintf(self::TEMPLATE_MSG, forum_htmlencode($msg[1]), forum_htmlencode($msg[0]));
-		}
-
-		if (!empty($messages_list))
-		{
-			$m = sprintf(self::TEMPLATE_MSG_BLOCK, implode('', $messages_list));
-			if ($just_return) {
-				$this->clear();
-				return $m;
-			}
+		$message = sprintf(self::TEMPLATE_MSG, forum_htmlencode($this->message[1]), forum_htmlencode($this->message[0]));
 
-			echo $m;
+		$m = sprintf(self::TEMPLATE_MSG_BLOCK, $message);
+		if ($just_return) {
+			$this->clear();
+			return $m;
 		}
 
+		echo $m;
+
 		$this->clear();
 	}
 
@@ -81,41 +82,44 @@
 	//
 	private function clear()
 	{
-		$this->messages = array();
-		$this->save_messages();
+		$this->message = NULL;
+		$this->save_message();
 	}
 
 
 	//
 	private function add_message($message, $type)
 	{
-		array_push($this->messages, array($message, $type));
-
-		$this->save_messages();
+		$this->message = array($message, $type);
+		$this->save_message();
 	}
 
 
-	private function save_messages()
+	private function save_message()
 	{
-		 $_SESSION['punbb_forum_flash'] = serialize($this->messages);
+		$_SESSION['punbb_forum_flash'] = serialize($this->message);
 	}
 
 
-	private function get_messages()
+	private function get_message()
 	{
-		$messages = array();
+		$message = NULL;
 
 		if (isset($_SESSION['punbb_forum_flash'])) {
-			$tmp_messages = unserialize($_SESSION['punbb_forum_flash']);
+			$tmp_message = unserialize($_SESSION['punbb_forum_flash']);
 
-			if (is_array($tmp_messages))
-				$messages = $tmp_messages;
+			if (!is_null($tmp_message) && !empty($tmp_message))
+			{
+				if (is_array($tmp_message) && !empty($tmp_message[0]) && !empty($tmp_message[1]))
+				{
+					$message = $tmp_message;
+				}
+			}
 		}
 
-		return $messages;
+		return $message;
 	}
 }
 
-
 // Create the flash messenger adapter object
 $forum_flash = new FlashMessenger();
diff -urN punbb-1.4.1/include/functions.php punbb-1.4.2/include/functions.php
--- punbb-1.4.1/include/functions.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/functions.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads common functions used throughout the site.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -32,6 +32,45 @@
 }
 
 
+// Start PHP session
+function forum_session_start() {
+	static $forum_session_started = FALSE;
+
+	$return = ($hook = get_hook('fn_forum_session_start_start')) ? eval($hook) : null;
+	if ($return != null)
+		return;
+
+	// Check if session already started
+	if ($forum_session_started && session_id())
+		return;
+
+	session_cache_limiter(FALSE);
+
+	// Check session id
+	$forum_session_id = NULL;
+	if (isset($_COOKIE['PHPSESSID']))
+		$forum_session_id = $_COOKIE['PHPSESSID'];
+	else if (isset($_GET['PHPSESSID']))
+		$forum_session_id = $_GET['PHPSESSID'];
+
+	if (empty($forum_session_id) || !preg_match('/^[a-z0-9]{16,32}$/', $forum_session_id))
+	{
+		// Create new session id
+		$forum_session_id = random_key(32, FALSE, TRUE);
+		session_id($forum_session_id);
+	}
+
+	session_start();
+	if (!isset($_SESSION['initiated']))
+	{
+		session_regenerate_id();
+		$_SESSION['initiated'] = TRUE;
+	}
+
+	$forum_session_started = TRUE;
+}
+
+
 // Converts the CDATA end sequence ]]> into ]]&gt;
 function escape_cdata($str)
 {
@@ -90,7 +129,7 @@
 function forum_unregister_globals()
 {
 	$register_globals = @ini_get('register_globals');
-	if ($register_globals === "" || $register_globals === "0" || strtolower($register_globals) === "off")
+	if ($register_globals === '' || $register_globals === '0' || strtolower($register_globals) === 'off')
 		return;
 
 	// Prevent script.php?GLOBALS[foo]=bar
@@ -156,7 +195,7 @@
 
 		// Otherwise I am not aware of a work around...
 		else
-			error('The web server you are using is not correctly setting the REQUEST_URI variable.<br/>This usually means you are using IIS6, or an unpatched IIS7. Please either disable SEF URLs, upgrade to IIS7 and install any available patches or try a different web server.');
+			error('The web server you are using is not correctly setting the REQUEST_URI variable.<br />This usually means you are using IIS6, or an unpatched IIS7. Please either disable SEF URLs, upgrade to IIS7 and install any available patches or try a different web server.');
 	}
 }
 
@@ -475,8 +514,8 @@
 		{
 			$links['search'] = '<li id="navsearch"'.((FORUM_PAGE == 'search') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['search']).'">'.$lang_common['Search'].'</a></li>';
 			$links['profile'] = '<li id="navprofile"'.((substr(FORUM_PAGE, 0, 7) == 'profile') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['user'], $forum_user['id']).'">'.$lang_common['Profile'].'</a></li>';
-			$links['logout'] = '<li id="navlogout"><a href="'.forum_link($forum_url['logout'], array($forum_user['id'], generate_form_token('logout'.$forum_user['id']))).'">'.$lang_common['Logout'].'</a></li>';
 			$links['admin'] = '<li id="navadmin"'.((substr(FORUM_PAGE, 0, 5) == 'admin') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['admin_index']).'">'.$lang_common['Admin'].'</a></li>';
+			$links['logout'] = '<li id="navlogout"><a href="'.forum_link($forum_url['logout'], array($forum_user['id'], generate_form_token('logout'.$forum_user['id']))).'">'.$lang_common['Logout'].'</a></li>';
 		}
 	}
 
@@ -599,7 +638,7 @@
 		return $return;
 
 	if ($forum_page['num_pages'] == 1)
-		$item_info =  '<span class="item-info">'.sprintf($lang_common['Item info single'], $label, forum_number_format($total)).'</span>';
+		$item_info = '<span class="item-info">'.sprintf($lang_common['Item info single'], $label, forum_number_format($total)).'</span>';
 	else
 		$item_info = '<span class="item-info">'.sprintf($lang_common['Item info plural'], $label, forum_number_format($first), forum_number_format($forum_page['finish_at']), forum_number_format($total)).'</span>';
 
@@ -657,7 +696,7 @@
 			if ($current < 1 || $current > $num_pages)
 				continue;
 			else if ($current != $cur_page || $link_to_all)
-				$pages[] = '<a'.(empty($pages) ? ' class="first-item" ' : '').' href="'.forum_sublink($link, $forum_url_page, $current, $args).'">'.forum_number_format($current).'</a>';
+				$pages[] = '<a'.(empty($pages) ? ' class="first-item"' : '').' href="'.forum_sublink($link, $forum_url_page, $current, $args).'">'.forum_number_format($current).'</a>';
 			else
 				$pages[] = '<strong'.(empty($pages) ? ' class="first-item"' : '').'>'.forum_number_format($current).'</strong>';
 
@@ -666,12 +705,12 @@
 			if ($cur_page != ($num_pages-3) && $cur_page != ($num_pages-4))
 				$pages[] = '<span>'.$lang_common['Spacer'].'</span>';
 
-			$pages[] = '<a'.(empty($pages) ? ' class="first-item" ' : '').' href="'.forum_sublink($link, $forum_url_page, $num_pages, $args).'">'.forum_number_format($num_pages).'</a>';
+			$pages[] = '<a'.(empty($pages) ? ' class="first-item"' : '').' href="'.forum_sublink($link, $forum_url_page, $num_pages, $args).'">'.forum_number_format($num_pages).'</a>';
 		}
 
 		// Add a next page link
 		if ($num_pages > 1 && !$link_to_all && $cur_page < $num_pages)
-			$pages[] = '<a'.(empty($pages) ? ' class="first-item" ' : '').' href="'.forum_sublink($link, $forum_url_page, ($cur_page + 1), $args).'">'.$lang_common['Next'].'</a>';
+			$pages[] = '<a'.(empty($pages) ? ' class="first-item"' : '').' href="'.forum_sublink($link, $forum_url_page, ($cur_page + 1), $args).'">'.$lang_common['Next'].'</a>';
 	}
 
 	($hook = get_hook('fn_paginate_end')) ? eval($hook) : null;
@@ -844,7 +883,7 @@
 // Replace censored words in $text loader
 function censor_words($text)
 {
-	global $forum_db;
+	global $forum_db, $forum_censors;
 
 	$return = ($hook = get_hook('fn_censor_words_start')) ? eval($hook) : null;
 	if ($return != null)
@@ -876,10 +915,15 @@
 // Replace censored words in $text
 function censor_words_do($forum_censors, $text, $unicode)
 {
-	static $search_for, $replace_with;
+	static $search_for = NULL;
+	static $replace_with = NULL;
+
+	if (is_null($search_for))
+		$search_for = array();
+
+	if (is_null($replace_with))
+		$replace_with = array();
 
-	$search_for = array();
-	$replace_with = array();
 
 	if (!empty($forum_censors))
 	{
@@ -1033,7 +1077,7 @@
 // Return a list of all URL schemes installed
 function get_scheme_packs()
 {
-  	$schemes = array();
+	$schemes = array();
 
 	if ($handle = opendir(FORUM_ROOT.'include/url'))
 	{
@@ -3098,7 +3142,7 @@
 	while (preg_match('#<!-- ?forum_include "([^/\\\\]*?)" ?-->#', $tpl_maint, $cur_include))
 	{
 		if (!file_exists(FORUM_ROOT.'include/user/'.$cur_include[1]))
-			error('Unable to process user include &lt;!-- forum_include "'.forum_htmlencode($cur_include[1]).'" --&gt; from template maintenance.tpl.<br/>There is no such file in folder /include/user/.');
+			error('Unable to process user include &lt;!-- forum_include "'.forum_htmlencode($cur_include[1]).'" --&gt; from template maintenance.tpl.<br />There is no such file in folder /include/user/.');
 
 		ob_start();
 		include FORUM_ROOT.'include/user/'.$cur_include[1];
@@ -3220,7 +3264,7 @@
 	while (preg_match('#<!-- ?forum_include "([^/\\\\]*?)" ?-->#', $tpl_redir, $cur_include))
 	{
 		if (!file_exists(FORUM_ROOT.'include/user/'.$cur_include[1]))
-			error('Unable to process user include &lt;!-- forum_include "'.forum_htmlencode($cur_include[1]).'" --&gt; from template redirect.tpl.<br/>There is no such file in folder /include/user/.');
+			error('Unable to process user include &lt;!-- forum_include "'.forum_htmlencode($cur_include[1]).'" --&gt; from template redirect.tpl.<br />There is no such file in folder /include/user/.');
 
 		ob_start();
 		include FORUM_ROOT.'include/user/'.$cur_include[1];
@@ -3241,7 +3285,7 @@
 // Display a simple error message
 function error()
 {
-	global $forum_config;
+	global $forum_config, $lang_common;
 
 	if (!headers_sent())
 	{
@@ -3279,6 +3323,33 @@
 		$forum_config['o_gzip'] = '0';
 	}
 
+	// Set a default error messages string if the script failed before $common_lang loaded
+	if (empty($lang_common['Forum error header']))
+	{
+		$lang_common['Forum error header'] = 'Sorry! The page could not be loaded.';
+	}
+
+	if (empty($lang_common['Forum error description']))
+	{
+		$lang_common['Forum error description'] = 'This is probably a temporary error. Just refresh the page and retry. If problem continues, please check back in 5-10 minutes.';
+	}
+
+	if (empty($lang_common['Forum error location']))
+	{
+		$lang_common['Forum error location'] = 'The error occurred on line %1$s in %2$s';
+	}
+
+	if (empty($lang_common['Forum error db reported']))
+	{
+		$lang_common['Forum error db reported'] = 'Database reported:';
+	}
+
+	if (empty($lang_common['Forum error db query']))
+	{
+		$lang_common['Forum error db query'] = 'Failed query:';
+	}
+
+
 	// Empty all output buffers and stop buffering
 	while (@ob_end_clean());
 
@@ -3290,42 +3361,45 @@
 <!DOCTYPE html>
 <html lang="en" dir="ltr">
 <head>
-	<meta charset="utf-8"/>
+	<meta charset="utf-8" />
 	<title>Error - <?php echo forum_htmlencode($forum_config['o_board_title']) ?></title>
+	<style>
+		strong	{ font-weight: bold; }
+		body	{ margin: 50px; font: 85%/150% verdana, arial, sans-serif; color: #222; max-width: 55em; }
+		h1		{ color: #a00000; font-weight: normal; font-size: 1.45em; }
+		code	{ font-family: monospace, sans-serif; }
+		.error_line { color: #999; font-size: .95em; }
+	</style>
 </head>
-<body style="margin: 40px; font: 85%/150% verdana, arial, sans-serif; color: #222; max-width: 55em;">
-<h1 style="color: #a00000; font-weight: normal;">An error was encountered</h1>
+<body>
+	<h1><?php echo forum_htmlencode($lang_common['Forum error header']) ?></h1>
 <?php
-
 	if (isset($message))
 		echo '<p>'.$message.'</p>'."\n";
+	else
+		echo '<p>'.forum_htmlencode($lang_common['Forum error description']).'</p>'."\n";
 
 	if ($num_args > 1)
 	{
 		if (defined('FORUM_DEBUG'))
 		{
-			if (isset($file) && isset($line))
-				echo '<p>The error occurred on line '.$line.' in '.$file.'</p>'."\n";
-
 			$db_error = isset($GLOBALS['forum_db']) ? $GLOBALS['forum_db']->error() : array();
 			if (!empty($db_error['error_msg']))
 			{
-				echo '<p><strong>Database reported:</strong> '.forum_htmlencode($db_error['error_msg']).(($db_error['error_no']) ? ' (Errno: '.$db_error['error_no'].')' : '').'.</p>'."\n";
+				echo '<p><strong>'.forum_htmlencode($lang_common['Forum error db reported']).'</strong> '.forum_htmlencode($db_error['error_msg']).(($db_error['error_no']) ? ' (Errno: '.$db_error['error_no'].')' : '').'.</p>'."\n";
 
 				if ($db_error['error_sql'] != '')
-					echo '<p><strong>Failed query:</strong> <code>'.forum_htmlencode($db_error['error_sql']).'</code></p>'."\n";
+					echo '<p><strong>'.forum_htmlencode($lang_common['Forum error db query']).'</strong> <code>'.forum_htmlencode($db_error['error_sql']).'</code></p>'."\n";
 			}
+
+			if (isset($file) && isset($line))
+				echo '<p class="error_line">'.forum_htmlencode(sprintf($lang_common['Forum error location'], $line, $file)).'</p>'."\n";
 		}
-		else
-			echo '<p style="font-size: .95em;"><strong>Note:</strong> For detailed error information (necessary for troubleshooting), enable "DEBUG mode".<br/>To enable "DEBUG mode", open up&nbsp;the file config.php in&nbsp;a&nbsp;text editor, add a&nbsp;line that looks like <nobr>"define(\'FORUM_DEBUG\', 1);"</nobr> (without the quotation marks), and re-upload the file.<br/>Once you\'ve solved the problem, it&nbsp;is recommended that "DEBUG mode" be&nbsp;turned off again (just remove the line from the file and re-upload it).</p>'."\n";
 	}
-
 ?>
-
 </body>
 </html>
 <?php
-
 	// If a database connection was established (before this error) we close it
 	if (isset($GLOBALS['forum_db']))
 		$GLOBALS['forum_db']->close();
diff -urN punbb-1.4.1/include/loader.php punbb-1.4.2/include/loader.php
--- punbb-1.4.1/include/loader.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/loader.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loader class for inject CSS and JS files.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on Drupal code
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -23,7 +23,7 @@
 	private $libs;
 
 	// Class instance
-    private static $instance;
+	private static $instance;
 
 
 	// Start of life
@@ -41,20 +41,20 @@
 
 
 	// Singleton
-    public static function singleton() {
-        if (!isset(self::$instance)) {
-            $c = __CLASS__;
-            self::$instance = new $c;
-        }
-
-        return self::$instance;
-    }
+	public static function singleton() {
+		if (!isset(self::$instance)) {
+			$c = __CLASS__;
+			self::$instance = new $c;
+		}
 
+		return self::$instance;
+	}
 
-    // Clone forbiden
-    public function __clone() {
-        trigger_error('Clone is forbiden.', E_USER_ERROR);
-    }
+
+	// Clone forbiden
+	public function __clone() {
+		trigger_error('Clone is forbiden.', E_USER_ERROR);
+	}
 
 
 	// Add JS url to load
@@ -471,7 +471,7 @@
 		}
 		elseif ($a['weight'] > $b['weight'])
 		{
-		    return 1;
+			return 1;
 		}
 		else
 		{
@@ -517,8 +517,8 @@
 		}
 		else
 		{
-		    // "downlevel-revealed".
-		    $data = "\n<!--[if $expression]><!-->".$data."<!--<![endif]-->";
+			// "downlevel-revealed".
+			$data = "\n<!--[if $expression]><!-->".$data."<!--<![endif]-->";
 		}
 
 		return $data;
